"use strict";
(function() {
    var f = function(s, date, o) {
        if(o == null) {
            o = {}
        }
        if(document.querySelector(s) == null) {
            console.error('selector is not defined');

            return;
        }
        this.selector = s;
        this.el = document.querySelector(s);
        this.type = o.type || 'vertical';
        this.format = o.format || 'days' //days or weeks
        this.date = date;
        this.cw = this.el.querySelector('.c_week');
        this.cd = this.el.querySelector('.c_day');
        this.ch = this.el.querySelector('.c_hour');
        this.cm = this.el.querySelector('.c_min');
        this.cs = this.el.querySelector('.c_sec');
        this.sid=null;
        this.w=null;
        this.d=null;
        this.h=null;
        this.m=null;
        this.s=null;

        if(this.format == "days") {
            if(this.cw) {
                this.cw.remove();
            }
            if(this.el.querySelector('.week')) {
                this.el.querySelector('.week').remove();
            }
        }

        this.el.classList.add('_countdown_box');
        this.el.classList.add('_countdown_'+this.format);
        this.el.classList.add('_countdown_'+this.type);

        // var $limit_date = "2018-11-21 09:00:00";
        return this.init();
    }

    f.prototype = {
        init: function() {
            var self = this;
            this.count();
            this.sid = setInterval(function() {
                self.count.call(self);
            }, 500);

            return this;
        },
        count: function() {
            var $now = (new Date()-0) / 1000;
            var $offset = ((new Date(this.date)-0) / 1000) - $now;

            if($offset <= 0) {
                $minsec = [0,0];
                $hourmin = [0,0];
                $dayhour = [0,0];
                $weekday = [0,0];
                clearInterval(this.sid);
            } else {
                var $minsec = (($offset/60)+"").split(".");
                if($minsec[1]) {
                    $minsec[1] = "0."+$minsec[1];
                    $minsec[1] = Math.round(60 * $minsec[1]);
                    if($minsec[1] == 60) {
                        $minsec[1] = 0;
                    }
                } else {
                    $minsec[1] = 0;
                }

                var $hourmin = (($minsec[0] / 60)+"").split(".");
                if($hourmin[1]) {
                    $hourmin[1] = "0."+$hourmin[1];
                    $hourmin[1] = Math.round(60 * $hourmin[1]);
                } else {
                    $hourmin[1] = 0;
                }

                var $dayhour = (($hourmin[0] / 24)+"").split(".");
                if($dayhour[1]) {
                    $dayhour[1] = "0."+$dayhour[1];
                    $dayhour[1] = Math.round(24 * $dayhour[1]);
                } else {
                    $dayhour[1] = 0;
                }

                if(this.format == "weeks") {
                    var $weekday = (($dayhour[0] / 7)+"").split(".");
                    if($weekday[1]) {
                        $weekday[1] = "0."+$weekday[1];
                        $weekday[1] = Math.round(7 * $weekday[1]);
                    } else {
                        $weekday[1] = 0;
                    }
                }
            }

            if(this.s != $minsec[1]) {
                this.s = $minsec[1];
                this.update(this.s, this.cs);
            }

            if(this.m != $hourmin[1]) {
                this.m = $hourmin[1];
                this.update(this.m, this.cm);
            }

            if(this.h != $dayhour[1]) {
                this.h = $dayhour[1];
                this.update(this.h, this.ch);
            }
            if(this.format == "days") {
                if(this.d != $dayhour[0]) {
                    this.d = $dayhour[0];
                    this.update(this.d, this.cd, "0");
                }
            } else if(this.format == "weeks") {
                if(this.d != $weekday[1]) {
                    this.d = $weekday[1];
                    this.update(this.d, this.cd, "0");
                }

                if(this.w != $weekday[0]) {
                    this.w = $weekday[0];
                    this.update(this.w, this.cw, "0");
                }
            }

            if($offset <= 0) {
                var event = new CustomEvent('countEnd', {bubbles: false, detail: this});
                this.el.dispatchEvent(event);
            }

            return this;
        },
        update: function(i, e, p) {
            var a = [];
            if(p == null) {
                p = "00";
            }
            i += "";
            e.innerHTML = "";
            if(1 < i.length) {
                for(var j = 0; j < i.length; j++) {
                    e.appendChild((function(){
                        var s = document.createElement('span');
                        s.innerText = i.substr(j, 1);
                        return s;
                    })())
                }
                return;
            } else {
                if(p == "00") {
                    e.appendChild((function(){
                        var s = document.createElement('span');
                        s.innerText = "0";
                        return s;
                    })())
                }
                e.appendChild((function(){
                    var s = document.createElement('span');
                    s.innerText = i.substr(j, 1);
                    return s;
                })())
            }
        }
    }

    function sprint(i, d)
    {
        if(d != null && 1 < d.length) {
            i = ( d + i ).substr(-(d.length));
        }
        return i;
    }

    if(!window.Countdown) {
        window.Countdown = f;
    }

    window.addEventListener('load', function(){
        document.dispatchEvent(new CustomEvent('countdownReady'), false);
    });
})();
